// input file: 256 color bitmap, 12x24 size characters 0..127, starts from bottom left point
// data size: 128x12x24=36864 bytes
// file size: 37942 bytes
// throw away: 37942-36864=1078 bytes (0x436)

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>

FILE *fin;
FILE *fout;

char buf[65536];

int main(int argc, char *argv[]) {
  unsigned char c;
  int i, j, k, n;
  
  if ((fin = fopen("font_12x24_03.bmp","rb")) == NULL) {
    printf("nincs fin\n");
    getchar();
    exit(1);
  }

  fout = fopen("font_pck.vhd","wt");

  fprintf(fout, "-- 0..127 ASCII characters 12x24 bitmap\n\n");
  fprintf(fout, "library ieee;\n");
  fprintf(fout, "use ieee.std_logic_1164.all;\n\n");
  fprintf(fout, "package font_pck is\n\n");
  fprintf(fout, "type font_type is array(0 to 127) of std_logic_vector(0 to 287);\n");
  fprintf(fout, "constant font : font_type := \n(");

  fread(&buf[0], 1, 1078, fin);
  n = fread(&buf[0], 1, 36864, fin);
  printf("%d\n", n);
 
  for (i=0; i<128; i++) {
    fprintf(fout, "\"");

    for (j=23; j>=0; j--) {
//       c = buf[i+j*128];

       for (k=0; k<12; k++) {
		  c = buf[(i+j*128)*12 + k];

          if (c == 0)
             fprintf(fout, "0");
          else
             fprintf(fout, "1");
          
          c = c << 1;
       }
    }
    if (i == 127)
       fprintf(fout, "\");\n");
    else
       fprintf(fout, "\",\n ");
  }

  fprintf(fout, "\nend package;\n\n");
  fprintf(fout, "package body font_pck is\n");
  fprintf(fout, "end package body;\n");

  fflush(fout);
  fclose(fin);
  fclose(fout);
  return 0;
}
