#include <stdio.h>
#include <stdlib.h>

void error(int errorcode);
unsigned int hex2bin(char c);

FILE* txt = NULL;
FILE* coe = NULL;
FILE* coec = NULL;

int main(int argc, char *argv[]) {
  char line[512];
  int i, j;
  unsigned int c;

  if ((txt = fopen("display_1280x800_106x33.txt", "rb")) == NULL) {
    printf("Missing %s", "display_1280x800_106x33.txt"); error(1);
  }

  if ((coe = fopen("txt_ram_init.coe", "wt")) == NULL) {
    printf("Cannot open %s", "txt_ram_init.coe"); error(2);
  }
  fprintf(coe, "memory_initialization_radix=16;\n");
  fprintf(coe, "memory_initialization_vector=\n");

  if ((coec = fopen("txt_color_ram_init.coe", "wt")) == NULL) {
    printf("Cannot open %s", "txt_color_ram_init.coe"); error(2);
  }
  fprintf(coec, "memory_initialization_radix=16;\n");
  fprintf(coec, "memory_initialization_vector=\n");

for (i=0; i<33; i++) {
  fread(&line[0], 108, 1, txt);

  for (j=0; j<106; j++) {
    c = line[j];
    if (c == 0x20) 
      c = 0;
    else if ((c == '{') || (c == '}') || (c == '[') || (c == ']') || (c == '_') || (c == '|') ||
             (c == '\'') || (c == '=') || (c == '(') || (c == ')') ||
             (c == '+') || (c == '`') || (c == '^') ||
             (c == '!') || (c == '"') || (c == '*') || (c == ',') || (c == '\\') ||
             (i == 29)) //|| (i == 24))
      c = (c & 0x7F) | 0x080;   // blue
    else
      c = (c & 0x7F) | 0x380;   // white

    fprintf(coe,  "%02X", c & 0x7F);
    fprintf(coec, "%01X", (c >> 7) & 0x07);

    if ((i != 32) || (j != 105)) {
       fprintf(coe,  ",\n");
       fprintf(coec, ",\n");
    }
  }
}

  fprintf(coe, ";\n");
  fprintf(coec, ";\n");

  if (txt != NULL) fclose(txt);
  if (coe != NULL) fclose(coe);
  if (coec != NULL) fclose(coec);
  return 0;
}

void error(int error_code) {
  if (txt != NULL) fclose(txt);
  if (coe != NULL) fclose(coe);
  if (coec != NULL) fclose(coec);
  printf("\nError %d\n", error_code);
  exit(1);
}

unsigned int hex2bin(char c) {
  if ((c >= '0') && (c <= '9')) 
    return(c - 0x30);
  else if ((c >= 'A') && (c <= 'F'))
    return(c - 'A' + 10);
  else
    return(0);
}
