--------------------------------------------------------------------------------
-- Copyright (c) 1995-2006 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 8.2i
--  \   \         Application : xaw2vhdl
--  /   /         Filename : dcm_cascade.vhd
-- /___/   /\     Timestamp : 09/16/2018 20:10:58
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: xaw2vhdl-st D:\projects\xilinx_scope\src\xilinx\coregen\\dcm_cascade.xaw D:\projects\xilinx_scope\src\xilinx\coregen\\dcm_cascade
--Design Name: dcm_cascade
--Device: xc3s500e-4fg320
--
-- Module dcm_cascade
-- Generated by Xilinx Architecture Wizard
-- Written for synthesis tool: XST

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity dcm_cascade is
   port ( U1_CLKIN_IN        : in    std_logic; 
          U1_RST_IN          : in    std_logic; 
          U1_CLKFX_OUT       : out   std_logic; 
          U1_CLKFX180_OUT    : out   std_logic; 
          U1_CLKIN_IBUFG_OUT : out   std_logic; 
          U1_CLK0_OUT        : out   std_logic; 
          U1_STATUS_OUT      : out   std_logic_vector (2 downto 0); 
          U2_CLK0_OUT        : out   std_logic; 
          U2_LOCKED_OUT      : out   std_logic; 
          U2_STATUS_OUT      : out   std_logic_vector (2 downto 0));
end dcm_cascade;

architecture BEHAVIORAL of dcm_cascade is
   signal GND1               : std_logic;
   signal STATUS_float       : std_logic_vector (4 downto 0);
   signal STATUS_float1      : std_logic_vector (4 downto 0);
   signal U1_CLKFB_IN        : std_logic;
   signal U1_CLKFX_BUF       : std_logic;
   signal U1_CLKFX180_BUF    : std_logic;
   signal U1_CLKIN_IBUFG     : std_logic;
   signal U1_CLK0_BUF        : std_logic;
   signal U1_LOCKED_INV_IN   : std_logic;
   signal U2_CLKFB_IN        : std_logic;
   signal U2_CLKIN_BUF       : std_logic;
   signal U2_CLK0_BUF        : std_logic;
   signal U2_LOCKED_INV_RST  : std_logic;
   -- Period Jitter (unit interval) for block DCM_INST1 = 0.11 UI
   -- Period Jitter (Peak-to-Peak) for block DCM_INST1 = 0.70 ns
   component DCM_SP
      generic( CLK_FEEDBACK : string :=  "1X";
               CLKDV_DIVIDE : real :=  2.0;
               CLKFX_DIVIDE : integer :=  1;
               CLKFX_MULTIPLY : integer :=  4;
               CLKIN_DIVIDE_BY_2 : boolean :=  FALSE;
               CLKIN_PERIOD : real :=  10.0;
               CLKOUT_PHASE_SHIFT : string :=  "NONE";
               DESKEW_ADJUST : string :=  "SYSTEM_SYNCHRONOUS";
               DFS_FREQUENCY_MODE : string :=  "LOW";
               DLL_FREQUENCY_MODE : string :=  "LOW";
               DUTY_CYCLE_CORRECTION : boolean :=  TRUE;
               FACTORY_JF : bit_vector :=  x"C080";
               PHASE_SHIFT : integer :=  0;
               STARTUP_WAIT : boolean :=  FALSE;
               DSS_MODE : string :=  "NONE");
      port ( CLKIN    : in    std_logic; 
             CLKFB    : in    std_logic; 
             RST      : in    std_logic; 
             PSEN     : in    std_logic; 
             PSINCDEC : in    std_logic; 
             PSCLK    : in    std_logic; 
             DSSEN    : in    std_logic; 
             CLK0     : out   std_logic; 
             CLK90    : out   std_logic; 
             CLK180   : out   std_logic; 
             CLK270   : out   std_logic; 
             CLKDV    : out   std_logic; 
             CLK2X    : out   std_logic; 
             CLK2X180 : out   std_logic; 
             CLKFX    : out   std_logic; 
             CLKFX180 : out   std_logic; 
             STATUS   : out   std_logic_vector (7 downto 0); 
             LOCKED   : out   std_logic; 
             PSDONE   : out   std_logic);
   end component;
   
   component INV
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   
   component BUFG
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   
   component IBUFG
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   
begin
   GND1 <= '0';
   U2_CLKIN_BUF <= U1_CLKFB_IN;
   U1_CLKIN_IBUFG_OUT <= U1_CLKIN_IBUFG;
   U1_CLK0_OUT <= U1_CLKFB_IN;
   U1_CLK0_OUT <= U2_CLKIN_BUF;
   U2_CLK0_OUT <= U2_CLKFB_IN;
   DCM_INST1 : DCM_SP
   generic map( CLK_FEEDBACK => "1X",
            CLKDV_DIVIDE => 2.0,
            CLKFX_DIVIDE => 1,
            CLKFX_MULTIPLY => 3,
            CLKIN_DIVIDE_BY_2 => FALSE,
            CLKIN_PERIOD => 20.0,
            CLKOUT_PHASE_SHIFT => "NONE",
            DESKEW_ADJUST => "SYSTEM_SYNCHRONOUS",
            DFS_FREQUENCY_MODE => "LOW",
            DLL_FREQUENCY_MODE => "LOW",
            DUTY_CYCLE_CORRECTION => TRUE,
            FACTORY_JF => x"8080",
            PHASE_SHIFT => 0,
            STARTUP_WAIT => FALSE)
      port map (CLKFB=>U1_CLKFB_IN,
                CLKIN=>U1_CLKIN_IBUFG,
                DSSEN=>GND1,
                PSCLK=>GND1,
                PSEN=>GND1,
                PSINCDEC=>GND1,
                RST=>U1_RST_IN,
                CLKDV=>open,
                CLKFX=>U1_CLKFX_BUF,
                CLKFX180=>U1_CLKFX180_BUF,
                CLK0=>U1_CLK0_BUF,
                CLK2X=>open,
                CLK2X180=>open,
                CLK90=>open,
                CLK180=>open,
                CLK270=>open,
                LOCKED=>U1_LOCKED_INV_IN,
                PSDONE=>open,
                STATUS(7 downto 3)=>STATUS_float(4 downto 0),
                STATUS(2 downto 0)=>U1_STATUS_OUT(2 downto 0));
   
   DCM_INST2 : DCM_SP
   generic map( CLK_FEEDBACK => "1X",
            CLKDV_DIVIDE => 2.0,
            CLKFX_DIVIDE => 1,
            CLKFX_MULTIPLY => 4,
            CLKIN_DIVIDE_BY_2 => FALSE,
            CLKIN_PERIOD => 6.66667,
            CLKOUT_PHASE_SHIFT => "FIXED",
            DESKEW_ADJUST => "SYSTEM_SYNCHRONOUS",
            DFS_FREQUENCY_MODE => "LOW",
            DLL_FREQUENCY_MODE => "LOW",
            DUTY_CYCLE_CORRECTION => TRUE,
            FACTORY_JF => x"8080",
            PHASE_SHIFT => 70,
            STARTUP_WAIT => FALSE)
      port map (CLKFB=>U2_CLKFB_IN,
                CLKIN=>U2_CLKIN_BUF,
                DSSEN=>GND1,
                PSCLK=>GND1,
                PSEN=>GND1,
                PSINCDEC=>GND1,
                RST=>U2_LOCKED_INV_RST,
                CLKDV=>open,
                CLKFX=>open,
                CLKFX180=>open,
                CLK0=>U2_CLK0_BUF,
                CLK2X=>open,
                CLK2X180=>open,
                CLK90=>open,
                CLK180=>open,
                CLK270=>open,
                LOCKED=>U2_LOCKED_OUT,
                PSDONE=>open,
                STATUS(7 downto 3)=>STATUS_float1(4 downto 0),
                STATUS(2 downto 0)=>U2_STATUS_OUT(2 downto 0));
   
   INV_INST : INV
      port map (I=>U1_LOCKED_INV_IN,
                O=>U2_LOCKED_INV_RST);
   
   U1_CLKFX_BUFG_INST : BUFG
      port map (I=>U1_CLKFX_BUF,
                O=>U1_CLKFX_OUT);
   
   U1_CLKFX180_BUFG_INST : BUFG
      port map (I=>U1_CLKFX180_BUF,
                O=>U1_CLKFX180_OUT);
   
   U1_CLKIN_IBUFG_INST : IBUFG
      port map (I=>U1_CLKIN_IN,
                O=>U1_CLKIN_IBUFG);
   
   U1_CLK0_BUFG_INST : BUFG
      port map (I=>U1_CLK0_BUF,
                O=>U1_CLKFB_IN);
   
   U2_CLK0_BUFG_INST : BUFG
      port map (I=>U2_CLK0_BUF,
                O=>U2_CLKFB_IN);
   
end BEHAVIORAL;


