library ieee;
use ieee.std_logic_1164.all;

package xilinx_pck is

component dcm
	port (	
		clk		: in std_logic;
		reset		: in std_logic;
		clk_main	: out std_logic;
		clk_lcd		: out std_logic;
		clk_sampler	: out std_logic;
		clk_adc		: out std_logic;
		locked		: out std_logic;
		status0		: out std_logic_vector (7 downto 0);
		status1		: out std_logic_vector (7 downto 0);
		status2		: out std_logic_vector (7 downto 0);
		status3		: out std_logic_vector (7 downto 0)
	);
end component;

component display_ram
	port (
	clka: IN std_logic;
	dina: IN std_logic_VECTOR(36 downto 0);
	addra: IN std_logic_VECTOR(10 downto 0);
	wea: IN std_logic_VECTOR(0 downto 0);
	clkb: IN std_logic;
	addrb: IN std_logic_VECTOR(10 downto 0);
	doutb: OUT std_logic_VECTOR(36 downto 0));
end component;

component sampler_ram
	port (
	clka: IN std_logic;
	dina: IN std_logic_VECTOR(31 downto 0);
	addra: IN std_logic_VECTOR(10 downto 0);
	wea: IN std_logic_VECTOR(0 downto 0);
	clkb: IN std_logic;
	addrb: IN std_logic_VECTOR(10 downto 0);
	doutb: OUT std_logic_VECTOR(31 downto 0));
end component;

component txt_color_ram
	port (
	clka: IN std_logic;
	dina: IN std_logic_VECTOR(2 downto 0);
	addra: IN std_logic_VECTOR(12 downto 0);
	wea: IN std_logic_VECTOR(0 downto 0);
	clkb: IN std_logic;
	addrb: IN std_logic_VECTOR(12 downto 0);
	doutb: OUT std_logic_VECTOR(2 downto 0));
end component;

component txt_ram
	port (
	clka: IN std_logic;
	dina: IN std_logic_VECTOR(6 downto 0);
	addra: IN std_logic_VECTOR(12 downto 0);
	wea: IN std_logic_VECTOR(0 downto 0);
	clkb: IN std_logic;
	addrb: IN std_logic_VECTOR(12 downto 0);
	doutb: OUT std_logic_VECTOR(6 downto 0));
end component;

end package;

package body xilinx_pck is
end package body;

